



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[iOS]利用通知实现监听系统键盘</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[iOS]利用通知实现监听系统键盘</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-18 15:58:20 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<pre class="prettyprint linenums">//<br />
//  ViewController.m<br />
//  text<br />
//<br />
//  Created by 李东旭 on 16/1/22.<br />
//  Copyright &copy; 2016年 李东旭. All rights reserved.<br />
//

#import &lt;UIKit/UIKit.h&gt;<br />
#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad {<br />
    [super viewDidLoad];

    UITextView *textV = [[UITextView alloc] initWithFrame:self.view.bounds];<br />
    [self.view addSubview:textV];

    // 1. 添加通知<br />
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyBoardChange:) name:UIKeyboardWillShowNotification object:nil];<br />
    // 键盘将要出现 UIKeyboardWillShowNotification<br />
    // 键盘已经出现 UIKeyboardDidShowNotification<br />
    // 键盘将要隐藏 UIKeyboardWillHideNotification<br />
    // 键盘已经隐藏 UIKeyboardDidHideNotification

}

// 2. 键盘已经出现调用的触发方法<br />
- (void)keyBoardChange:(NSNotification *)noti<br />
{<br />
    NSLog(@"%@", noti);<br />
// 打印noti<br />
    /*<br />
     0x7f84584d1000 {name = UIKeyboardDidShowNotification; userInfo = {<br />
// 键盘动画执行节奏<br />
     UIKeyboardAnimationCurveUserInfoKey = 7;

// 键盘动画的时间<br />
     UIKeyboardAnimationDurationUserInfoKey = "0.25";

// 键盘的bounds<br />
     UIKeyboardBoundsUserInfoKey = "NSRect: {{0, 0}, {375, 258}}";

// 键盘的起始center<br />
     UIKeyboardCenterBeginUserInfoKey = "NSPoint: {187.5, 796}";

// 键盘的结束center<br />
     UIKeyboardCenterEndUserInfoKey = "NSPoint: {187.5, 538}";

// 键盘开始动画前的位置（也就是消失时）<br />
     UIKeyboardFrameBeginUserInfoKey = "NSRect: {{0, 667}, {375, 258}}";

// 键盘结束动画后的位置（也就是弹出了）<br />
     UIKeyboardFrameEndUserInfoKey = "NSRect: {{0, 409}, {375, 258}}";

     UIKeyboardIsLocalUserInfoKey = 1;<br />
     }}<br />
     */

    // 3. 那么如何获取这个值呢<br />
    NSDictionary *noKey = [noti userInfo];<br />
    NSValue *value = noKey[@"UIKeyboardBoundsUserInfoKey"];<br />
    // 注意，这个的value 是CGRect类型的（所以下面必须调用CGRectValue方法<br />
    NSLog(@"%f", [value CGRectValue].size.height);

}

@end</pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390z66jq.html">visual studio 2012如何彻底删除TFS上的团队项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4egr59.html">让IE下支持Html5的placeholder属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o5vxv9.html">JQuery插件开发 - 模板</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkn0me8.html">oracle之spool详细使用总结（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpj55j9.html">C语言连接Oracle</a>
		</li>
						<li><a href="https://www.batexi.com/a/950mnjz8.html">解决IE增强配置的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzgl548.html">Binlog的三个业务应用场景</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1njr2q.html">SublimeText用FileHeader给代码文件生成头部注释</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me4mlrq.html">&lbrack;JLOI2015&rsqb;装备购买</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y4v2n8.html">python中线程和进程&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g04lmq.html">vue使用中遇到的，以及vue1&period;0到vue2&period;0新手踩的坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwzx2j9.html">selenium之 文件上传所有方法整理总结【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/960zpr49.html">生活实遇记-Kindle好久没用，屏幕一直处于电池状态，怎么解决？</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25ee63q.html">Series转化为DataFrame数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1pm7xq.html">VIM空格和TAB转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdpkyj9.html">【BUG记录】记一次游戏越来越卡的BUG</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwzpzd8.html">Visual Studio Plus 开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm1mz49.html">使用Bootstrap&plus;metisMenu完成简单的后台管理界面</a>
		</li>
						<li><a href="https://www.batexi.com/a/963lpyj9.html">PHP中oop面向对象基础知识（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkx77n8.html">merge into优化sql（转）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pjp17k9.html">Ngrok 内网穿透神器&lpar;转载&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wk7yvq.html">【Sum Root to Leaf Numbers】cpp</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm1z369.html">移动端 js touch事件</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wk7loq.html">CSS3 绘制360安仔小精灵&lbrack;原创&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjmn7k9.html">用PHP对数据库内容进行操作（改）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7m7z0kq.html">NYOJ-20 吝啬的国度  AC                                                    分类：            NYOJ             2014-01-23 12&colon;18    200人阅读    评论&lpar;0&rpar;    收藏</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y4z00q.html">vsm 的理解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z5rg29.html">&period;NET设计模式（18）：迭代器模式（Iterator Pattern）（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1mmdr9.html">Unity3D 将 Unity 嵌入WPF中的一些研究笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjmkgz9.html">Fbric、Ansible、Docker、Chaos Monkey：DevOps工具的年中回顾</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
